#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <ogcsys.h>
#include <gccore.h>
#include <stdarg.h>
#include <ctype.h>
#include <unistd.h>
#include <sys/errno.h>

#include "tools.h"
#include "sysmenu.h"
#include "main.h"

#define RAMFILE	"sd:/geckomem1.bin"

//---------------------------------------------------------------------------------
u32 be32(const u8 *p){
//---------------------------------------------------------------------------------
	return (p[0] << 24) | (p[1] << 16) | (p[2] << 8) | p[3];
}

//---------------------------------------------------------------------------------
u16 be16(const u8 *p){
//---------------------------------------------------------------------------------
	return (p[0] << 8) | p[1];
 }

//---------------------------------------------------------------------------------
u64 be64(const u8 *p){
//---------------------------------------------------------------------------------
	return ((u64)be32(p) << 32) | be32(p + 4);
}
//---------------------------------------------------------------------------------
void wbe16(u8 *p, u16 x)
//---------------------------------------------------------------------------------
{
	p[0] = x >> 8;
	p[1] = x;
}
//---------------------------------------------------------------------------------
void wbe32(u8 *p, u32 x)
//---------------------------------------------------------------------------------
{
	wbe16(p, x >> 16);
	wbe16(p + 2, x);
}

//---------------------------------------------------------------------------------
u32 read32(u32 addr)
//---------------------------------------------------------------------------------
{
	u32 x;

	__asm__("lwz %0,0(%1) ; sync" : "=r"(x) : "b"(0xc0000000 | addr));

	return x;
}
//---------------------------------------------------------------------------------
u16 read16(u32 addr)
//---------------------------------------------------------------------------------
{
	u16 x;

	__asm__("lhz %0,0(%1) ; sync" : "=r"(x) : "b"(0xc0000000 | addr));

	return x;
}
//---------------------------------------------------------------------------------
void write32(u32 addr, u32 x)
//---------------------------------------------------------------------------------
{
	__asm__("stw %0,0(%1) ; eieio" : : "r"(x), "b"(0xc0000000 | addr));
}

//---------------------------------------------------------------------------------
char ascii(char s)
//---------------------------------------------------------------------------------
{
	if(s < 0x20) return '.';
	if(s > 0x7E) return '.';
	return s;
}

//---------------------------------------------------------------------------------
void hexdump(void *d, int len)
//---------------------------------------------------------------------------------
{
	u8 *data;
	int off=0;
	int i;
	data = (u8*)d;
	while(off<len) {
		printf("%08x  ",off);
		for(i=0; i<8; i++) {
			if((i+off)>=len) {
				printf("   ");
			} else {
				printf("%02x ",data[off+i]);
			}
		}
		printf(" ");
		for(i=0; i<8; i++) {
			if((i+off)>=len) {
				printf(" ");
			} else {
				printf("%c",ascii(data[off+i]));
			}
		}
		printf("\n");
		off +=8;
	}
}

//---------------------------------------------------------------------------------
void exitme()
//---------------------------------------------------------------------------------
{
	if (loaderhbc)
	{
		if (WII_LaunchTitle(0x000100014A4F4449ULL) < 0)
			if (WII_LaunchTitle(0x0001000148415858ULL) < 0)
				WII_ReturnToMenu();
	}
	else
		WII_ReturnToMenu();
}
